#random rotation
scoreboard players set in math 1
scoreboard players set in1 math 4
function endless_city:rng/range

scoreboard players operation $rot endless_city.data = out math

scoreboard players set $X endless_city.data -16
scoreboard players set $Y endless_city.data -1
scoreboard players set $Z endless_city.data -16

#---------------------------------#
#1 is default rotation
#if 2, swap and invert X
execute if score $rot endless_city.data matches 2 run scoreboard players operation $X endless_city.data >< $Z endless_city.data
execute if score $rot endless_city.data matches 2 run scoreboard players operation $X endless_city.data *= #-1 endless_city.data
#if 3, invert both data
execute if score $rot endless_city.data matches 3 run scoreboard players operation $X endless_city.data *= #-1 endless_city.data
execute if score $rot endless_city.data matches 3 run scoreboard players operation $Z endless_city.data *= #-1 endless_city.data
#if 4, swap and invert Z
execute if score $rot endless_city.data matches 4 run scoreboard players operation $X endless_city.data >< $Z endless_city.data
execute if score $rot endless_city.data matches 4 run scoreboard players operation $Z endless_city.data *= #-1 endless_city.data
#---------------------------------#

setblock ~ ~ ~ minecraft:structure_block
data merge block ~ ~ ~ {mode:"LOAD",integrity:1.0f,showboundingbox:0b,ignoreEntities:0b,name:"endless_city:legacy_grid"}
execute store result block ~ ~ ~ posX int 1 run scoreboard players get $X endless_city.data
execute store result block ~ ~ ~ posY int 1 run scoreboard players get $Y endless_city.data
execute store result block ~ ~ ~ posZ int 1 run scoreboard players get $Z endless_city.data

execute if score $rot endless_city.data matches 1 run data modify block ~ ~ ~ rotation set value "None"
execute if score $rot endless_city.data matches 2 run data modify block ~ ~ ~ rotation set value "CLOCKWISE_90"
execute if score $rot endless_city.data matches 3 run data modify block ~ ~ ~ rotation set value "CLOCKWISE_180"
execute if score $rot endless_city.data matches 4 run data modify block ~ ~ ~ rotation set value "COUNTERCLOCKWISE_90"

setblock ~ ~1 ~ minecraft:redstone_block
fill ~ ~0 ~ ~ ~1 ~ minecraft:air

execute if block ~-17 ~-1 ~ minecraft:air positioned ~-33 ~ ~ unless entity @e[type=minecraft:marker,tag=city_generator,distance=..0.1] run summon minecraft:marker ~ ~ ~ {Tags:["city_generator"]}
execute if block ~17 ~-1 ~ minecraft:air positioned ~33 ~ ~ unless entity @e[type=minecraft:marker,tag=city_generator,distance=..0.1] run summon minecraft:marker ~ ~ ~ {Tags:["city_generator"]}
execute if block ~ ~-1 ~17 minecraft:air positioned ~ ~ ~33 unless entity @e[type=minecraft:marker,tag=city_generator,distance=..0.1] run summon minecraft:marker ~ ~ ~ {Tags:["city_generator"]}
execute if block ~ ~-1 ~-17 minecraft:air positioned ~ ~ ~-33 unless entity @e[type=minecraft:marker,tag=city_generator,distance=..0.1] run summon minecraft:marker ~ ~ ~ {Tags:["city_generator"]}

kill @s[tag=city_generator]